package com.fladsrud.databasecreator.gui;
import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import com.borland.jbcl.layout.*;
import java.sql.*;
import java.io.File;
import com.fladsrud.databasecreator.DatabaseConnection;

public class GUICreator extends JFrame implements com.fladsrud.databasecreator.Constants {
  private JScrollPane jScrollPane1 = new JScrollPane();
  private BorderLayout borderLayout1 = new BorderLayout();
  private JPanel jPanel1 = new JPanel();
  private BorderLayout borderLayout2 = new BorderLayout();
  private JPanel jPanel2 = new JPanel();
  private JButton btnClose = new JButton();
  private FlowLayout flowLayout1 = new FlowLayout();
  private JButton btnExcecute = new JButton();
  private JPanel pnlHeader = new JPanel();
  private JPanel pnlContent = new JPanel();
  private XYLayout xYLayout1 = new XYLayout();
  private JScrollPane jScrollPane2 = new JScrollPane();
  private JTextArea txtaQueries = new JTextArea();
  private JTextArea txtaComment = new JTextArea();
  private JScrollPane jScrollPane3 = new JScrollPane();
  private JTextArea txtaStatus = new JTextArea();
  private JLabel jLabel1 = new JLabel();
  private JTextField txtfDBname = new JTextField();
  private JButton btnClear = new JButton();
  private JButton btnChooseCatalogForDB = new JButton();
  private JLabel jLabel2 = new JLabel();
  private JTextField txtfCatalog = new JTextField();
  private File katalogDB = new File(defaultdbfolder);
  private JButton btnClearStatus = new JButton();
  private FlowLayout flowLayout2 = new FlowLayout();
  private JButton jButton1 = new JButton();

  public GUICreator() {
    super("hsqlDB database creator - Developed by Tom Fladsrud");
    try {
      new com.fladsrud.databasecreator.menu.Menu(this);
      jbInit();
      this.txtaComment.setBackground(this.btnClose.getBackground());
      this.txtfCatalog.setText(katalogDB.getAbsolutePath());
//      this.setSize(587, 590);
//      this.setSize(575, 610);
      this.setSize(605, 611);
      com.fladsrud.gui.WindowLocation.centerWindow(this);
      this.setResizable(false);

      this.show();
    }
    catch(Exception e) {
      e.printStackTrace();
    }
  }

 /*     private static void centerVindu (JFrame f) {
        Dimension skjermSize = Toolkit.getDefaultToolkit().getScreenSize();
        Dimension vinduSize = f.getSize();
        if (vinduSize.height > skjermSize.height) {
            vinduSize.height = skjermSize.height;
        }
        if (vinduSize.width > skjermSize.width) {
            vinduSize.width = skjermSize.width;
        }
        f.setLocation((skjermSize.width - vinduSize.width)/2, (skjermSize.height
                - vinduSize.height)/2);
    }
*/


  private void jbInit() throws Exception {
    this.getContentPane().setLayout(borderLayout1);
    jPanel1.setLayout(borderLayout2);
    jPanel2.setPreferredSize(new Dimension(10, 40));
    jPanel2.setLayout(flowLayout1);
    btnClose.setText("Close");
    btnClose.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        btnClose_actionPerformed(e);
      }
    });
    flowLayout1.setAlignment(FlowLayout.RIGHT);
    btnExcecute.setText("Run Query");
    btnExcecute.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        btnExcecute_actionPerformed(e);
      }
    });
    pnlHeader.setPreferredSize(new Dimension(10, 57));
    pnlHeader.setLayout(flowLayout2);
    pnlContent.setLayout(xYLayout1);
    txtaComment.setEditable(false);
    txtaComment.setText("Type or paste the query to be executed. Separate commands with ;");
    txtaStatus.setEditable(false);
    jLabel1.setText("Database name");
    btnClear.setText("Clear SQL");
    btnClear.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        btnClear_actionPerformed(e);
      }
    });
    btnChooseCatalogForDB.setText("Browse");
    btnChooseCatalogForDB.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        btnChooseCatalogForDB_actionPerformed(e);
      }
    });
    jLabel2.setText("Catalog to place the database");
    txtfCatalog.setEditable(false);
    btnClearStatus.setText("Clear Status");
    btnClearStatus.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        btnClearStatus_actionPerformed(e);
      }
    });
    this.setDefaultCloseOperation(WindowConstants.DO_NOTHING_ON_CLOSE);
    jButton1.setText("jButton1");
    flowLayout2.setHgap(0);
    flowLayout2.setVgap(0);
    pnlContent.add(jScrollPane2,         new XYConstraints(4, 111, 587, 163));
    pnlContent.add(jScrollPane3,     new XYConstraints(4, 280, 587, 178));
    jScrollPane3.getViewport().add(txtaStatus, null);
    jScrollPane2.getViewport().add(txtaQueries, null);
    this.getContentPane().add(jScrollPane1,  BorderLayout.CENTER);
    jScrollPane1.getViewport().add(jPanel1, null);
    jPanel1.add(jPanel2,  BorderLayout.SOUTH);
    jPanel2.add(btnExcecute, null);
    jPanel2.add(btnClearStatus, null);
    jPanel2.add(btnClear, null);
    jPanel2.add(btnClose, null);
    jPanel1.add(pnlHeader, BorderLayout.NORTH);
    jPanel1.add(pnlContent, BorderLayout.CENTER);
//    pnlHeader.add(new JLabel(new ImageIcon(headerleftpath)), BorderLayout.WEST);
//    pnlHeader.add(new JLabel(new ImageIcon(headerpath)), BorderLayout.CENTER);
//    pnlHeader.add(new JLabel(new ImageIcon(headerleftpath)), null);
    pnlHeader.add(new JLabel(new ImageIcon(headerpath)), null);
//    pnlHeader.add(new JLabel(new ImageIcon(headerleftpath)), null);
    pnlHeader.add(new JLabel(new ImageIcon(headerlogopath)), null);
  //  pnlHeader.add(new JLabel(new ImageIcon(headerleftpath)), null);
    for (int i=0; i< 10; i++){
    pnlHeader.add(new JLabel(new ImageIcon(headerrightpath)), null);
    pnlHeader.add(new JLabel(new ImageIcon(headerrightpath)), null);
    pnlHeader.add(new JLabel(new ImageIcon(headerrightpath)), null);
    pnlHeader.add(new JLabel(new ImageIcon(headerrightpath)), null);
    pnlHeader.add(new JLabel(new ImageIcon(headerrightpath)), null);
    pnlHeader.add(new JLabel(new ImageIcon(headerrightpath)), null);
    pnlHeader.add(new JLabel(new ImageIcon(headerrightpath)), null);
    pnlHeader.add(new JLabel(new ImageIcon(headerrightpath)), null);
    pnlHeader.add(new JLabel(new ImageIcon(headerrightpath)), null);
    pnlHeader.add(new JLabel(new ImageIcon(headerrightpath)), null);
}
    pnlContent.add(txtfDBname,     new XYConstraints(102, 50, 489, 19));
    pnlContent.add(jLabel1, new XYConstraints(6, 50, -1, -1));
    pnlContent.add(txtaComment,             new XYConstraints(5, 74, 586, 32));
    pnlContent.add(txtfCatalog,     new XYConstraints(174, 20, 333, -1));
    pnlContent.add(jLabel2,   new XYConstraints(5, 20, -1, -1));
    pnlContent.add(btnChooseCatalogForDB,                               new XYConstraints(512, 17, -1, -1));

  }

  void btnClose_actionPerformed(ActionEvent e) {
    System.exit(0);
  }


  public File velgKatalog(String defaultPath, String tittel){
      File returfil = null;
      try{
        File defaultpath = new File(defaultPath);
        JFileChooser filvelger = new JFileChooser(defaultpath);
        filvelger.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);
        filvelger.setDialogTitle(tittel);
        filvelger.setCurrentDirectory(defaultpath);
        int resultat = filvelger.showOpenDialog(this);
        if (resultat == JFileChooser.CANCEL_OPTION)
          return null;
        else{
          returfil = filvelger.getSelectedFile();
        }
      }catch(Exception e){
        JOptionPane.showMessageDialog(null, "Error during selection of database path.", "Error", JOptionPane.ERROR_MESSAGE);
      }
      return returfil;
      }


  void btnExcecute_actionPerformed(ActionEvent e) {
    if(this.txtfDBname.getText().trim().equals("")){
      this.txtaStatus.append("Error::Field database name must have value");
      this.txtfDBname.requestFocus();
      return;
    }
    try{
      if(!katalogDB.exists())
        katalogDB.mkdirs();
    }catch(Exception ef){
      ef.printStackTrace();
    }
    String dbname = katalogDB.getAbsolutePath()+"\\"+this.txtfDBname.getText().trim();
    DatabaseConnection dbcon;

    try{
      dbcon = new DatabaseConnection(dbname, dbpw, dbuser, dbURL, forname);
    }catch(Exception ed){
      this.txtaStatus.append("Could not connect to database.\n"+ed.getMessage());
      ed.printStackTrace();
      return;
    }

    String queries = this.txtaQueries.getText();
    int q=0;
    String arr_queries[] = queries.split(";");
    try{
      for(; q<arr_queries.length; q++){
        dbcon.query(arr_queries[q].trim());
        String output[][] = dbcon.getQueryOutput();
        if (output!=null){
          for(int i = 0;i<output.length;i++){
           String line="\n";
           for(int x = 0;x<output[0].length;x++){
             line +=(x==0?"":"\t\t")+output[i][x];
              }
              txtaStatus.append(line);
           }
txtaStatus.append("\n");
        }
      }
    }catch(SQLException sqle){
      this.txtaStatus.append("ERROR AT LINE "+q+"\n"+arr_queries[q]+"\nMessage from system: "+sqle.getMessage()+"\nROLLBACK WILL BE PERFORMED");
      sqle.printStackTrace();
      try{
        dbcon.query("ROLLBACK");
        txtaStatus.append("\nROLLBACK WAS SUCCESSFUL");
      }catch(SQLException sqle2){
          txtaStatus.append("\nROLLBACK FAILED");
      }
      return;
    }
    try{
      dbcon.query("COMMIT");
    this.txtaStatus.append("QUERY EXCECUTED SUCCESSFULLY");
    }catch(SQLException sqle2){txtaStatus.append("\nCOMMIT FAILED");}

  }

  void btnClear_actionPerformed(ActionEvent e) {
    this.txtaQueries.setText("");
  }

  void btnChooseCatalogForDB_actionPerformed(ActionEvent e) {
    File katalogtmp = katalogDB;
    katalogDB = this.velgKatalog(katalogDB.getAbsolutePath(), "Choose path for the database");
    if(katalogDB == null){
      katalogDB = katalogtmp;
    }
    this.txtfCatalog.setText(katalogDB.getAbsolutePath());
  }

  void btnClearStatus_actionPerformed(ActionEvent e) {
    this.txtaStatus.setText("");
  }




}