package com.fladsrud.databasecreator.menu;


import java.awt.Dialog;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import javax.swing.*;

public class FileMenu extends JMenuBar
{
    private JMenu mnuFile;
    private JMenuItem mniCloseWindow;

    private JFrame parent;

    public FileMenu(JFrame parent)
    {
        mnuFile = new JMenu();
        mniCloseWindow = new JMenuItem();
        this.parent = parent;

        mniCloseWindow.addActionListener(new ActionListener() {

            public void actionPerformed(ActionEvent e)
            {
                mniCloseWindow_actionPerformed(e, "");
            }

        }
);
        addCommons();
        parent.setJMenuBar(this);
    }

    void mniCloseWindow_actionPerformed(ActionEvent e, String str)
    {
        parent.dispose();
    }


    private void addCommons()
    {
        mnuFile.setText("File");
        mniCloseWindow.setText("Close");
        add(mnuFile);
        mnuFile.add(mniCloseWindow);
    }



}
