package com.fladsrud.databasecreator.menu;

public class HelpHeader {
  private int index;
  private String header;
  private HelpHeader subHeader[] = null;
  HelpText helptext = null;

  public HelpHeader(int index, String header, HelpHeader subHeader[], HelpText helptext) {
    this.index = index;
    this.header = header;
    this.subHeader = subHeader;
    this.helptext = helptext;
  }

  public int getIndex(){
    return index;
  }
  public String getHeader(){
    return header;
  }
  public HelpHeader[] getSubHeader(){
    return subHeader;
  }
  public HelpText getHelpText(){
    return helptext;
  }

  public String toString(){
    return header;
  }

}