package com.fladsrud.databasecreator.menu.gui;


import com.fladsrud.gui.MessageBox;
import com.fladsrud.gui.WindowLocation;
import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.*;
import javax.swing.*;
import javax.swing.border.Border;
import javax.swing.border.TitledBorder;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;
import javax.swing.text.JTextComponent;

public class About extends JDialog
{

    public About(JFrame frame, String strTitle, boolean modality, String strOm, String strInfo, String strOverskriftInfo, String imgPath)
    {
        super(frame, strTitle, modality);
        pnlBakgrunn = new JPanel();
        borderLayout1 = new BorderLayout();
        pnlKnapper = new JPanel();
        pnlInnhold = new JPanel();
        btnOK = new JButton();
        tabOm = new JTabbedPane();
        borderLayout2 = new BorderLayout();
        pnlOm = new JPanel();
        pnlInfo = new JPanel();
        borderLayout3 = new BorderLayout();
        pnlLogo = new JPanel();
        pnlTekst = new JPanel();
        borderLayout4 = new BorderLayout();
        scrOm = new JScrollPane();
        txtaOm = new JTextArea();
        bgColor = Color.white;
        omFarge = Color.white;
        infoTekstColor = Color.blue;
        omTekstColor = Color.black;
        infoFarge = Color.white;
        borderLayout5 = new BorderLayout();
        borderLayout6 = new BorderLayout();
        pnlInfoOverskrift = new JPanel();
        pnlInfoInnhold = new JPanel();
        borderLayout7 = new BorderLayout();
        pnlInfoLogo = new JPanel();
        borderLayout8 = new BorderLayout();
        pnlInfoOverTxt = new JPanel();
        borderLayout9 = new BorderLayout();
        scrInfo = new JScrollPane();
        txtInfo = new JTextArea();
        txtaOverInfo = new JTextArea();
        jTextArea2 = new JTextArea();
        borderLayout10 = new BorderLayout();
        this.imgPath = "img/Foxy2004.gif";
        pnlLisens = new JPanel();
        jScrollPane1 = new JScrollPane();
        borderLayout11 = new BorderLayout();
        txtaHsqldbLisens = new JTextArea();
        try
        {
            omTekst = strOm;
            infoTekst = strInfo;
            this.strOverskriftInfo = strOverskriftInfo;
            this.imgPath = imgPath;
            jbInit();
            setSize(400, 400);
            WindowLocation.centerWindow(this);
            show();
        }
        catch(Exception e)
        {
            e.printStackTrace();
        }
    }

    private void jbInit()
        throws Exception
    {
        border1 = BorderFactory.createEmptyBorder(20, 20, 20, 20);
        border2 = BorderFactory.createEmptyBorder(10, 10, 10, 10);
        border3 = BorderFactory.createCompoundBorder(BorderFactory.createBevelBorder(0, Color.white, Color.white, new Color(124, 124, 124), new Color(178, 178, 178)), BorderFactory.createEmptyBorder(10, 10, 10, 10));
        border4 = BorderFactory.createEmptyBorder(5, 5, 5, 5);
        border5 = BorderFactory.createEmptyBorder();
        border6 = BorderFactory.createEmptyBorder();
        border7 = BorderFactory.createEmptyBorder(3, 6, 0, 0);
        border8 = BorderFactory.createEmptyBorder();
        border9 = BorderFactory.createEmptyBorder(5, 0, 0, 0);
        titledBorder1 = new TitledBorder(BorderFactory.createEtchedBorder(Color.white, new Color(165, 163, 151)), "Lisens for hsqldb database");
        pnlBakgrunn.setLayout(borderLayout1);
        pnlKnapper.setBorder(border9);
        pnlKnapper.setPreferredSize(new Dimension(10, 40));
        btnOK.setText("OK");
        btnOK.addActionListener(new ActionListener() {

            public void actionPerformed(ActionEvent e)
            {
                btnOK_actionPerformed(e);
            }

        }
);
        pnlInnhold.setLayout(borderLayout2);
        pnlOm.setLayout(borderLayout3);
        pnlLogo.setPreferredSize(new Dimension(10, 100));
        pnlLogo.setLayout(borderLayout5);
        pnlTekst.setLayout(borderLayout4);
        pnlTekst.setBorder(border1);
        scrOm.setBorder(null);
        txtaOm.setBorder(null);
        txtaOm.setEditable(false);
        txtaOm.setLineWrap(true);
        txtaOm.setWrapStyleWord(true);
        setDefaultCloseOperation(2);
        setResizable(false);
        pnlInfoOverskrift.setBackground(Color.white);
        pnlInfoOverskrift.setPreferredSize(new Dimension(10, 50));
        pnlInfoOverskrift.setLayout(borderLayout7);
        pnlInfoLogo.setLayout(borderLayout8);
        pnlInfoLogo.setBackground(Color.white);
        pnlInfoLogo.setPreferredSize(new Dimension(150, 40));
        pnlInfoOverTxt.setBackground(Color.white);
        pnlInfoOverTxt.setLayout(borderLayout10);
        pnlInfoInnhold.setBorder(border2);
        pnlInfoInnhold.setLayout(borderLayout9);
        scrInfo.setBorder(null);
        txtaOverInfo.setFont(new Font("Dialog", 1, 12));
        txtaOverInfo.setBorder(border7);
        txtaOverInfo.setEditable(false);
        txtaOverInfo.setText(strOverskriftInfo);
        txtaOverInfo.setLineWrap(true);
        txtaOverInfo.setWrapStyleWord(true);
        txtInfo.setBorder(null);
        txtInfo.setEditable(false);
        txtInfo.setLineWrap(true);
        txtInfo.setWrapStyleWord(true);
        pnlLisens.setLayout(borderLayout11);
        jScrollPane1.setBorder(titledBorder1);
        txtaHsqldbLisens.setText(" ");
        getContentPane().add(pnlBakgrunn, "Center");
        pnlBakgrunn.add(pnlKnapper, "South");
        pnlBakgrunn.add(pnlInnhold, "Center");
        pnlKnapper.add(btnOK, null);
        pnlInnhold.add(tabOm, "Center");
        tabOm.add(pnlOm, "  Om  ");
        tabOm.add(pnlInfo, "Info");
        tabOm.setBorder(BorderFactory.createEmptyBorder());
        pnlOm.add(pnlLogo, "North");
        pnlOm.add(pnlTekst, "Center");
        pnlTekst.add(scrOm, "Center");
        scrOm.getViewport().add(txtaOm, null);
        txtaOm.setText(omTekst);
        txtInfo.setText(infoTekst);
        pnlInfo.setLayout(borderLayout6);
        pnlInfo.add(pnlInfoOverskrift, "North");
        pnlInfo.add(pnlInfoInnhold, "Center");
        txtaOm.setForeground(omTekstColor);
        txtaOverInfo.setForeground(infoTekstColor);
        pnlLogo.add(new JLabel(new ImageIcon(imgPath)), "Center");
        pnlInfoLogo.add(new JLabel(new ImageIcon(imgPath)), "Center");
        pnlInfoOverskrift.add(pnlInfoLogo, "East");
        pnlInfoOverskrift.add(pnlInfoOverTxt, "Center");
        pnlInfoOverTxt.add(txtaOverInfo, "Center");
        pnlInfoInnhold.add(scrInfo, "Center");
        tabOm.add(pnlLisens, "Lisens hsqldb");
        scrInfo.getViewport().add(txtInfo, null);
        pnlLisens.add(jScrollPane1, "Center");
        jScrollPane1.getViewport().add(txtaHsqldbLisens, null);
        txtInfo.setCaretPosition(0);
        tabOm.addChangeListener(new ChangeListener() {

            public void stateChanged(ChangeEvent e)
            {
                tabOm_stateChanged(e);
            }

        }
);
        setFarge();
        pnlBakgrunn.setBorder(border3);
        txtInfo.setForeground(infoTekstColor);
        pnlInfoOverskrift.setBorder(border4);
        pnlInfo.setBorder(border5);
        pnlOm.setBorder(border6);
        legglisenspE5skjerm("files/lisenshsqldb.txt");
        txtInfo.setFont(new Font("Dialog", 0, 12));
        txtaHsqldbLisens.setEditable(false);
    }

    private void setFarge()
    {
        pnlOm.setBackground(bgColor);
        pnlInfo.setBackground(bgColor);
        pnlLogo.setBackground(bgColor);
        pnlOm.setBackground(bgColor);
        pnlTekst.setBackground(bgColor);
        txtaOm.setBackground(bgColor);
        txtaOverInfo.setBackground(bgColor);
        txtInfo.setBackground(bgColor);
        scrInfo.setBackground(bgColor);
        scrOm.setBackground(bgColor);
        pnlInfoInnhold.setBackground(bgColor);
        pnlInfoLogo.setBackground(bgColor);
        pnlInfoOverTxt.setBackground(bgColor);
        pnlInfoOverskrift.setBackground(bgColor);
    }

    void btnOK_actionPerformed(ActionEvent e)
    {
        dispose();
    }

    void tabOm_stateChanged(ChangeEvent e)
    {
        if(bgColor.equals(omFarge))
            bgColor = infoFarge;
        else
            bgColor = omFarge;
        setFarge();
    }

    void legglisenspE5skjerm(String filnavn)
    {
        try
        {
            File fromFile = new File(filnavn);
            BufferedReader in = new BufferedReader(new FileReader(fromFile));
            String linje = "\nHSQLDB LISENCE:\n";
            txtaHsqldbLisens.append(String.valueOf(String.valueOf(linje.trim())).concat("\n"));
            while((linje = in.readLine()) != null)
                txtaHsqldbLisens.append(String.valueOf(String.valueOf(linje.trim())).concat("\n"));
            txtaHsqldbLisens.setCaretPosition(1);
        }
        catch(FileNotFoundException ef)
        {
            MessageBox.ErrorMessage("The systemet can not find the hsqldb licence", "Licence file missing");
        }
        catch(IOException ioe)
        {
            MessageBox.ErrorMessage("Error reading hsqldb lisence", "Read error");
        }
    }

    private final String lisensfil = "files/lisenshsqldb.txt";
    private JPanel pnlBakgrunn;
    private BorderLayout borderLayout1;
    private JPanel pnlKnapper;
    private JPanel pnlInnhold;
    private JButton btnOK;
    private JTabbedPane tabOm;
    private BorderLayout borderLayout2;
    private JPanel pnlOm;
    private JPanel pnlInfo;
    private BorderLayout borderLayout3;
    private JPanel pnlLogo;
    private JPanel pnlTekst;
    private BorderLayout borderLayout4;
    private Border border1;
    private JScrollPane scrOm;
    private JTextArea txtaOm;
    private Color bgColor;
    private Color omFarge;
    private Color infoTekstColor;
    private Color omTekstColor;
    private Color infoFarge;
    private BorderLayout borderLayout5;
    private BorderLayout borderLayout6;
    private JPanel pnlInfoOverskrift;
    private JPanel pnlInfoInnhold;
    private BorderLayout borderLayout7;
    private JPanel pnlInfoLogo;
    private BorderLayout borderLayout8;
    private JPanel pnlInfoOverTxt;
    private Border border2;
    private BorderLayout borderLayout9;
    private JScrollPane scrInfo;
    private JTextArea txtInfo;
    private JTextArea txtaOverInfo;
    private JTextArea jTextArea2;
    private BorderLayout borderLayout10;
    private Border border3;
    private Border border4;
    private Border border5;
    private Border border6;
    private Border border7;
    private Border border8;
    private Border border9;
    private String omTekst;
    private String infoTekst;
    private String strOverskriftInfo;
    private String imgPath;
    private JPanel pnlLisens;
    private JScrollPane jScrollPane1;
    private BorderLayout borderLayout11;
    private TitledBorder titledBorder1;
    private JTextArea txtaHsqldbLisens;
}
