package com.fladsrud.databasecreator.menu;


import java.awt.Dialog;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import javax.swing.*;

public class Menu extends JMenuBar
{
    private JMenu mnuFile;
    private JMenuItem mniCloseWindow;
    private JMenu mnuHelp;
    private JMenuItem mniAbout;
    private JMenuItem mniHelp;

    private JFrame parent;

    public Menu(JFrame parent)
    {
        mnuFile = new JMenu();
        mniCloseWindow = new JMenuItem();
        mnuHelp = new JMenu();
        mniAbout = new JMenuItem();
        mniHelp = new JMenuItem();
        this.parent = parent;
        mniAbout.addActionListener(new ActionListener() {

            public void actionPerformed(ActionEvent e)
            {
                mniAbout_actionPerformed(e, "");
            }

        }
);
        mniHelp.addActionListener(new ActionListener() {

            public void actionPerformed(ActionEvent e)
            {
                mniHelp_actionPerformed(e, "");
            }

        }
);
        mniCloseWindow.addActionListener(new ActionListener() {

            public void actionPerformed(ActionEvent e)
            {
                mniCloseWindow_actionPerformed(e, "");
            }

        }
);
        addCommons();
        parent.setJMenuBar(this);
    }

    void mniCloseWindow_actionPerformed(ActionEvent e, String str)
    {
        parent.dispose();
    }

    void mniAbout_actionPerformed(ActionEvent e, String str)
    {
        String info = "Database Creator is a free tool for creation and administration of HSQLDB databases.\n"+
        "See the help menu for more infomation on how to create and administrate a HSQLDB database with Database Creator.";
        String about = "Database Creator is developed by\nTom Fladsrud\nEmail tom@fladsrud.com\n\nCopyright(c)2007 Tom Fladsrud";
        String overskriftinfo = "Information about Database Creator";
        String pathaboutimg = ".\\img\\FOXS.GIF";
        new com.fladsrud.databasecreator.menu.gui.About(parent, "About DatabaseCreator", true, about, info, overskriftinfo, pathaboutimg);
    }

    void mniHelp_actionPerformed(ActionEvent e, String str)
    {
        new com.fladsrud.databasecreator.menu.gui.Help(parent, "Help - Database Creator 1.0.3", false);
    }

    private void addCommons()
    {
        mnuFile.setText("File");
        mniCloseWindow.setText("Close");
        mnuFile.add(mniCloseWindow);
        mnuHelp.setText("Help");
        mniAbout.setText("About");
        mniHelp.setText("Help");
        mnuHelp.add(mniAbout);
        mnuHelp.add(mniHelp);
        add(mnuFile);
        add(mnuHelp);
    }



}
